SystemOrganization addCategory: #'CS528su13-Tiki'!

Object subclass: #TikiPage
	instanceVariableNames: 'linkDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

TikiPage class
	instanceVariableNames: 'pageID'!

TikiPage class
	instanceVariableNames: 'pageID'!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:30'!
initialize 
linkDictionary:=Dictionary new.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/2/2013 23:42'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempID tempText tempLength tempIndex|

rawLinkList:=aString findTokens:$#.
linkDictionary:= Dictionary new.
"(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ]."

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempID:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength.  linkDictionary at: (tempID asSymbol) put: tempText ].
! !

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 16:05'!
style 
	^'a:link {color:black; text-decoration:none}
	a:visited{color:black; text-decoration:none}
	a:hover { color:gray; text-decoration:none} 
	a:active { color:black; text-decoration:none'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'mainInput currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/2/2013 23:37'!
initialize
super initialize.
mainInput:='Test input'.
"currentPage:=TikiPage newFrom:'#fruit apples bananas #pets dog cat bear'."
currentPage:=TikiPage newFrom:'#red car apple stopsign mars #blue sky ocean blueberry'.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:23'!
processTagClick: aSymbol 
	self inform: 'You clicked on ',( aSymbol asString)! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 00:00'!
renderContentOn: html 
		html heading: 'TextClicking '.
		html break.
		html text: mainInput asString.
		html break.
		"this doesn't update currently"
		html form:[
		((currentPage linkDictionary) keys) do:[:each |
			html anchor
				callback: [self processTagClick: each];
				with: ((currentPage linkDictionary) at: each).
			html text:' '.
			].
		html break.
		html textInput
			on: #mainInput of: self.
		html submitButton 
			callback: [ "self inform: mainInput." currentPage makeLinkDictionaryFrom: mainInput];
			text:'Submit new links'
			]! !
TikiWebMain initialize!
